path = require 'path'
fs = require 'fs'
glob = require 'glob'
assert = require 'assert'
async = require 'async'
_ = require 'underscore'
{action} = require './core'
{mkdirs} = require './helpers'

@cat = (inPaths, outPath, opts = {}) ->
  assert typeof inPaths is 'string' or inPaths instanceof Array
  assert typeof outPath is 'string'
  inPaths = _(inPaths).chain().flatten().map((p) -> glob.sync p).flatten().uniq().value()
  action inPaths, [outPath], ({callback, log}) ->
    async.parallel(
      inPaths.map (p) -> (cb) -> fs.readFile p, 'utf8', cb
      (err, results) ->
        if err then throw err
        if opts.transform
          results =
            for content, i in results
              opts.transform content, path: inPaths[i]
        s = results.join ''
        mkdirs path.dirname(outPath), ->
          log 'writing ' + outPath
          fs.writeFile outPath, s, (err) ->
            if err then throw err
            callback()
    )
