{join, basename, dirname} = require 'path'
fs = require 'fs'
cs = require 'coffee-script'
glob = require 'glob'
assert = require 'assert'
{action} = require './core'
{mkdirs} = require './helpers'

@coffee = (sourceFiles, outputDir = '') ->
  assert typeof sourceFiles is 'string'
  assert typeof outputDir is 'string'
  glob.sync(sourceFiles).map (inPath) ->
    outPath =
      if outputDir
        join outputDir, basename(inPath).replace /\.coffee$/, '.js'
      else
        inPath.replace /\.coffee$/, '.js'
    action [inPath], [outPath], ({callback, log}) ->
      log 'reading ' + inPath
      fs.readFile inPath, 'utf8', (err, coffeeCode) ->
        if err then throw err
        log 'compiling'
        jsCode = cs.compile coffeeCode, filename: inPath
        mkdirs dirname(outPath), ->
          log 'writing ' + outPath
          fs.writeFile outPath, jsCode, (err) ->
            if err then throw err
            callback()
