{join, basename, dirname} = require 'path'
fs = require 'fs'
glob = require 'glob'
jade = require 'jade'
assert = require 'assert'
{action} = require './core'
{mkdirs} = require './helpers'

@jade = (sourceFiles, outputDir = '') ->
  assert typeof sourceFiles is 'string'
  assert typeof outputDir is 'string'
  glob.sync(sourceFiles).map (inPath) ->
    outPath =
      if outputDir
        join outputDir, basename(inPath).replace /\.jade$/, '.html'
      else
        inPath.replace /\.jade$/, '.html'
    action [inPath], [outPath], ({callback, log}) ->
      log 'reading ' + inPath
      fs.readFile inPath, 'utf8', (err, jadeCode) ->
        if err then throw err
        log 'rendering jade template'
        htmlCode = do jade.compile jadeCode
        mkdirs dirname(outPath), ->
          log 'writing ' + outPath
          fs.writeFile outPath, htmlCode, (err) ->
            if err then throw err
            callback()
