{join, basename, dirname} = require 'path'
glob = require 'glob'
assert = require 'assert'
{action} = require './core'
{spawn} = require 'child_process'

@sass = (sourceFiles, outputDir = '') ->
  assert typeof sourceFiles is 'string'
  assert typeof outputDir is 'string'
  glob.sync(sourceFiles).map (inPath) ->
    outPath =
      if outputDir
        join outputDir, basename(inPath).replace /\.sass$/, '.css'
      else
        inPath.replace /\.sass$/, '.css'
    action [inPath], [outPath], ({callback, log}) ->
      log 'spawning sass ' + inPath
      child = spawn 'sass', ['--no-cache', inPath, outPath]
      child.stdout.on 'data', (data) -> process.stdout.write data
      child.stderr.on 'data', (data) -> process.stderr.write data
      child.on 'exit', (code) ->
        if code then throw Error "Child process 'sass #{inPath} #{outPath}' returned exit code #{code}."
        callback()
